#!/bin/sh

HOME_DIR=/var/lib/jivelite
SETTINGS_DIR=$HOME_DIR/userpath/settings
SIZE=$(xrandr 2>/dev/null | sed -n "s/.* connected.* \([^+]*\)+.*/\1/p") #"
MAC=$(head -n1 /sys/class/net/eth?/address)

eval $(setting get --sh jive)

mkdir -p /data/photo

if [ ! -d $SETTINGS_DIR ]; then
	mkdir -p $SETTINGS_DIR
	cd $SETTINGS_DIR
	lc="$(setting get system.locale | cut -d _ -f 1 | tr "[:lower:]" "[:upper:]")"
	echo -n "settings = {[\"card.path\"]=\"/data/photos\",}" > ImageViewer.lua
	echo -n "settings = {skin=\"JogglerSkin_Custom\",}" > SelectSkin.lua
	if [ "$lc" = "DE" ]; then
		echo -n "settings = {hours=\"24\",dateformat=\"%a %d %b %Y\",shortdateformat=\"%m.%d.%Y\",weekstart=\"Monday\",}" > SetupDateTime.lua
	fi
	echo -n "settings = {locale=\"$lc\",}" > SetupLanguage.lua
	echo -n "settings = {timeout=30000,whenPlaying=\"NowPlaying:openScreensaver\",whenStopped=\"false:false\",whenOff=\"PowerOff:openScreensaver\",}" > ScreenSavers.lua
	if [ -x /usr/bin/squeezelite ]; then
		echo -n "settings = {playerId=\"$MAC\",playerInit={},}" > SlimDiscovery.lua
	fi
	echo -n "settings = {[\"$MAC\"]=\"applets/SetupWallpaper/wallpaper/jl_allegro.png\",}" > SetupWallpaper.lua
	echo -n "settings = {setupDone=true,}" > SetupWelcome.lua
	sed "s/local DEVICE_NAME .*/local DEVICE_NAME = \"$(setting get system.hostname)\"/" -i /usr/share/jive/jive/slim/LocalPlayer.lua
fi

if grep -q JogglerSkin_Custom $SETTINGS_DIR/SelectSkin.lua; then
	if [ -e "/usr/share/jive/applets/SetupWallpaper/wallpaper/jl${SIZE}_allegro.png" ]; then
		sed "s/\/jl[^_]*/\/jl${SIZE}/g" -i $SETTINGS_DIR/SetupWallpaper.lua
	else
		sed "s/\/jl[^_]*/\/jl1920x1080/g" -i $SETTINGS_DIR/SetupWallpaper.lua
	fi
fi

if [ -x /usr/bin/squeezelite ] && ! ps ax | grep -q "[s]queezelite"; then
	squeezelite -n $(setting get system.hostname) $(/usr/bin/setting get squeezelite.args) &
	sql=$!
fi

if [ -f $SETTINGS_DIR/SlimDiscovery.lua ]; then
	(
		playerId="$(sed 's/.*playerId="\([^"]*\).*\|.*/\1/' $SETTINGS_DIR/SlimDiscovery.lua)"
		if [ "$playerId" = '00:00:00:00:00:00' ]; then
			sed "s/00:00:00:00:00:00/$MAC/g" -i $SETTINGS_DIR/SlimDiscovery.lua
			playerId=$MAC
		fi
		serverIp="$(sed 's/.*ip="\([^"]*\).*\|.*/\1/' $SETTINGS_DIR/SlimDiscovery.lua)"
		if [ "$serverIp" ]; then
			timeout 30 sh -c "while ! echo -e '$playerId connected ?\nexit' | nc $serverIp 9090 2>/dev/null | grep -q 'connected 1'; do sleep 1; done"
			# Start playing on startup
			echo -e "$playerId play\nexit" | nc $serverIp 9090 >/dev/null
			if [ "$startupVolume" ]; then
				# set default volume on startup
				echo -e "$playerId mixer volume $startupVolume\nexit" | nc $serverIp 9090 >/dev/null
			fi
		fi
	) &
	ini=$!
fi

if [ "$hideMousepointer" ]; then
	export JIVE_NOCURSOR=1
fi

export JL_SCREEN_WIDTH=${SIZE%x*}
export JL_SCREEN_HEIGHT=${SIZE#*x}
export JL_SCALE=$scale
export JIVELITE_HOME=$HOME_DIR
jivelite
status=$?

test "$ini" && kill $ini 2>/dev/null
test "$sql" && kill $sql

exit $status
