--[[

A screensaver to power off the system.

--]]

local oo               = require("loop.simple")
local Framework        = require("jive.ui.Framework")
local Window           = require("jive.ui.Window")
local Timer            = require("jive.ui.Timer")
local Surface          = require("jive.ui.Surface")
local Icon             = require("jive.ui.Icon")
local Timer            = require("jive.ui.Timer")
local Applet           = require("jive.Applet")
local os               = require("os")

local jnt              = jnt
local appletManager    = appletManager

local bit = bit

module(..., Framework.constants)
oo.class(_M, Applet)


function openScreensaver(self, menuItem)
	self.sw, self.sh = Framework:getScreenSize()

	-- create window and icon
	self.window = Window("text_list")
	self.bg  = Surface:newRGBA(self.sw, self.sh)
	self.bg:filledRectangle(0, 0, self.sw, self.sh, 0x000000FF)

	self.bgicon = Icon("icon", self.bg)
	self.window:addWidget(self.bgicon)

	self.window:setShowFrameworkWidgets(false)

	self.window:addListener(bit.bor(EVENT_WINDOW_ACTIVE, EVENT_HIDE),
		function(event)
			local type = event:getType()
			if type == EVENT_WINDOW_ACTIVE then
				self:_screen("off")
			else
				self:_screen("on")
			end
			return EVENT_UNUSED
		end,
		true
	)

	self.window:addListener(EVENT_MOTION,
		function()
			self:_screen("on")
			self.window:hide()
			return EVENT_CONSUME
		end)

	-- register window as a screensaver
	local manager = appletManager:getAppletInstance("ScreenSavers")
	manager:screensaverWindow(self.window, _, _, _, 'PowerOff')

	self.window:show(Window.transitionFadeIn)
end


function closeScreensaver(self)
	self:_screen("on")
end

function onOverlayWindowShown(self)
	self:_screen("on")
end


function onOverlayWindowHidden(self)
	self:_setBrightness("off")
end

local timer = Timer(2000, function() Framework:setUpdateScreen(false) end, true)

function _screen(self, state)
	os.execute("sh /usr/share/jive/applets/PowerOff/poweroff.sh " .. state)
end
