--[[

A screensaver and menu entry to power off the system.

--]]


local oo            = require("loop.simple")
local AppletMeta    = require("jive.AppletMeta")
local os            = require("os")

local appletManager = appletManager
local jiveMain      = jiveMain

local EVENT_CONSUME = jive.ui.EVENT_CONSUME
local EVENT_QUIT    = jive.ui.EVENT_QUIT


module(...)
oo.class(_M, AppletMeta)


function jiveVersion(self)
	return 1, 1
end


function defaultSettings(self)
	local defaultSetting = {}
	return defaultSetting
end


function registerApplet(self)
end

function configureApplet(self)
	-- add ourselves to the end of the main menu
	jiveMain:addItem({
		id = 'appletPowerOff',
		iconStyle = 'hm_quit',
		node = 'home',
		text = self:string("POWEROFF"),
		callback = function()
			os.execute("sh /usr/share/jive/applets/PowerOff/poweroff.sh off")
			return (bit.bor(EVENT_CONSUME, EVENT_QUIT))
		end,
		weight = 1010,
	})
	-- add ourselfs as a screensaver
	appletManager:callService("addScreenSaver", self:string("POWEROFF"), "PowerOff", "openScreensaver", _, _, 100, "closeScreensaver")
end
